import java.io.*;
import ecc.*;

public class testgf {
    static char eraChar = '*';
    private static int parseString(String s, int c[])
    {
        int len = s.length();
        int clen = c.length;
        int i = 0;

        if (s.indexOf(',') >= 0) {
            int pos = 0;
            // example: 32, 23, 1, ...
            try {
                while (i < clen && pos < len) {
                    int po2 = s.indexOf(',', pos);
                    if (po2 < 0) po2 = len;
                    String ssub = s.substring(pos, po2).trim();
                    if (ssub.charAt(0) == eraChar) c[i] = -1;
                    else c[i] = Integer.parseInt(ssub);

                    i++; pos = po2+1;
                }
            } catch (NumberFormatException e) {
                System.out.print("Format error\n");
            }
        }
        else {
            byte b[] = s.toUpperCase().getBytes();
            // example "ABCD2"
            for (; i < clen && i < len; i++)
                if (s.charAt(i) == eraChar) c[i] = -1;
                else {
                    c[i] = b[i] - 65;
                    if (c[i] < 0) c[i] = c[i] + 42;
                }
        }
        return i;
    }

    public static void main (String args[])
    {
        int genpoly[] = {1, 1, 0, 1};   // 1+x+x^3
        GF gf8;
        int a, b, c;

        gf8 = new GF(2, genpoly);

        a = gf8.add(4, 5);
        b = gf8.mul(4, 5);
        c = gf8.log(5);
        System.out.print("4+5=");
        System.out.print(a);
        System.out.print("; 4*5=");
        System.out.print(b);
        System.out.print("; max =");
        System.out.println(gf8.max_num());

        int i;
        for (i = 0; i < 7; i++) {
            System.out.print("a^");
            System.out.print(i);
            System.out.print(" = ");
            System.out.println(gf8.power(i));
        }

        RS rs;
        rs = new RS(2, genpoly, 4);
        int rec[] = {3, 0, 1, 2, 3, 1, 0};
        for (i = 0; i < rec.length; i++)
            rec[i] = gf8.power(rec[i]);
        int S[] = new int[7];
        int n = rs.getSigma(rec);
        for (i = 1; i <= 4; i++) {
            System.out.print("S[");
            System.out.print(i);
            System.out.print("] = a^");
            System.out.println(gf8.log(S[i]));
        }

        GFPoly p1, p2;
        int p1c[] = {0,0,0,0,1};    // x^4
        int p2c[] = {gf8.power(3), gf8.power(4), gf8.power(4)};
        p1 = new GFPoly(gf8, p1c);
        p2 = new GFPoly(gf8, p2c);
        GFPoly p3 = p1.div(p2);
//        System.out.println(p3.toString());
//        u = new GFPoly(); v = new GFPoly(); r = new GFPoly();
//        p1.euclid(p1, p2, 2, 1);
//        System.out.println(p1.u1.toString());
//        System.out.println(p1.v1.toString());
//        System.out.println(p1.r1.toString());

        GFPoly re = new GFPoly(gf8, rec);
        System.out.println(re.fft().ifft().toString());


        int poly32[] = {1,0,1,0,0,1};
        GF gf32 = new GF(2, poly32);

        int rr[] = {1, gf8.power(1), gf8.power(2), -1, -1, -1, -1};
//        int rr[] = {1, 4, 2, 4, 7, 7, 2};
        System.out.println(rs.decode_freq(rr));
        System.out.println(rs.R.toString());
        System.out.println(rs.C.toString());

//        String sff = "12,23,34,1,34,3,1,34,1,3,1,4,3,4,1,";
//        String sff = "1*11111a*****g*****ss**abcde116";
        String sff = "6666666666666645**6666666666666666666";
        int len;
        rr = new int[31];
        System.out.println(len = parseString(sff, rr));
        RS rs32 = new RS(gf32, 16);

        System.out.println(rs32.decode_freq(rr));
        System.out.println(rs32.sigma.toString());
        System.out.println(rs32.omega.toString());
        System.out.println(GFPoly.euclid(rs32.sigma, rs32.omega).toString());
        System.out.println(rs32.R.toMatrixString(31));
//        System.out.println(rs32.E.toMatrixString(31));
//        System.out.println(rs32.C.toMatrixString(31));
//        for (int k = 0; k < len; k++)
            //System.out.println(rr[k]);
    }
}
